;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Half-Life Demo Launcher
;; by bunkahumpa
;; bh@scriptsurge.org - bunkahumpa.lookitsbobby.com
;; irc.GameSurge.net #script
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

alias hldl {
  if (!$dialog(hldl)) {
    dialog -md hldl hldl
  }
  else {
    dialog -v hldl
  }
}

menu menubar,channel,nicklist,status,query {
  -
  Half-Life Demo Launcher:hldl
  -
}

dialog hldl {
  title "Half-Life Demo Launcher"
  size -1 -1 192 105
  option dbu
  box "", 1, 0 21 108 71
  box "", 2, 107 21 85 71
  icon 3, 4 27 100 62
  text "Mod:", 4, 111 27 13 8
  text "", 5, 129 27 61 8
  text "Map:", 6, 111 37 13 8
  text "", 7, 129 37 61 8
  text "HLTV:", 8, 111 47 15 8
  text "", 9, 129 47 25 8
  box "", 10, 107 54 85 38
  button "Play Specified Demo", 11, 111 76 77 10, disable
  combo 13, 111 61 77 33, size drop
  box "", 14, 0 0 192 25
  button "Load Demo...", 15, 3 9 37 10
  edit "", 16, 43 9 145 10, autohs
  button "Close", 17, 151 93 37 10, ok
  box "", 18, 0 88 192 17
  button "About", 12, 3 93 37 10
  button "Resolution", 19, 111 93 37 10
}

dialog hldl_resolutions {
  title "Resolutions"
  size -1 -1 51 82
  option dbu
  box "", 1, 0 0 51 82
  radio "640 x 480", 2, 5 8 39 10
  radio "800 x 600", 3, 5 20 39 10
  radio "1024 x 768", 4, 5 32 39 10
  radio "1152 x 864", 5, 5 44 39 10
  radio "1280 x 960", 6, 5 56 39 10
  button "Save", 8, 7 68 37 10
}

on *:dialog:hldl:init:0:{
  did -a hldl 13 playdemo
  did -a hldl 13 viewdemo
  did -c hldl 13 1 1
  if ($exists($shortfn($scriptdirna.bmp)) == $true) {
    did -g hldl 3 $shortfn($scriptdirna.bmp)
  }
}

on *:dialog:hldl:sclick:15:{
  if ($readini($shortfn($scriptdirhldlsettings.ini),saved,lastdemopath) == $null) {
    set %hldl.demopath $sfile(c:\*.dem,Select a Demo:,Select)
  }
  else {
    set %hldl.demopath $sfile($readini($shortfn($scriptdirhldlsettings.ini),saved,lastdemopath) $+ *.dem,Select a Demo:,Select)
  }
  writeini " $+ $scriptdirhldlsettings.ini $+ " saved lastdemopath $remove(%hldl.demopath,$gettok(%hldl.demopath,-1,92))
  did -o hldl 16 1 %hldl.demopath
  did -a hldl 16
  did -o hldl 5 1 $demo(%hldl.demopath).mod
  did -o hldl 7 1 $demo(%hldl.demopath).map
  did -o hldl 9 1 $demo(%hldl.demopath).hltv
  did -e hldl 11
  if ($exists($shortfn($scriptdir $+ $demo(%hldl.demopath).map $+ .bmp)) == $true) {
    did -g hldl 3 $shortfn($scriptdir $+ $demo(%hldl.demopath).map $+ .bmp)
  }
  else {
    if ($exists($shortfn($scriptdirna.bmp)) == $true) {
      did -g hldl 3 $shortfn($scriptdirna.bmp)
    }
  }
}

on *:dialog:hldl:sclick:11:{
  if (%hldl.demopath != $null) {
    var %mod = $demo(%hldl.demopath).mod
    .copy -o " $+ %hldl.demopath $+ " " $+ $remove(%hldl.demopath,$gettok(%hldl.demopath,-1,92)) $+ hldldemo.dem $+ "
    run -p $remove(%hldl.demopath,$gettok(%hldl.demopath,-2-,92)) $+ hl.exe -game %mod $iif($readini(" $+ $scriptdirhldlsettings.ini $+ ",saved,resolution),-width $readini(" $+ $scriptdirhldlsettings.ini $+ ",saved,resolution)) + $+ $did(hldl,13) hldldemo.dem
    dialog -x hldl hldl
    unset %hldl.*
  }
}

on *:dialog:hldl:sclick:12:{
  var %msg = $input(Half-Life Demo Launcher $crlf by bunkahumpa $crlf $crlf E-Mail: bh@scriptsurge.org $crlf Website: http://bunkahumpa.lookitsbobby.com $crlf IRC: irc.GameSurge.net - #script,io,About)
}

on *:dialog:hldl:sclick:19:{
  if (!$dialog(hldl_resolutions)) {
    dialog -dm hldl_resolutions hldl_resolutions
  }
  else {
    dialog -v hldl_resolutions
  }
}

on *:dialog:hldl_resolutions:init:0:{
  if ($readini(" $+ $scriptdirhldlsettings.ini $+ ",saved,resolution) == 640) {
    did -c hldl_resolutions 2
  }
  if ($readini(" $+ $scriptdirhldlsettings.ini $+ ",saved,resolution) == 800) {
    did -c hldl_resolutions 3
  }
  if ($readini(" $+ $scriptdirhldlsettings.ini $+ ",saved,resolution) == 1024) {
    did -c hldl_resolutions 4
  }
  if ($readini(" $+ $scriptdirhldlsettings.ini $+ ",saved,resolution) == 1152) {
    did -c hldl_resolutions 5
  }
  if ($readini(" $+ $scriptdirhldlsettings.ini $+ ",saved,resolution) == 1280) {
    did -c hldl_resolutions 6
  }
}

on *:dialog:hldl_resolutions:sclick:8:{
  if ($did(hldl_resolutions,2).state == 1) {
    writeini " $+ $scriptdirhldlsettings.ini $+ " saved resolution 640
  } 
  if ($did(hldl_resolutions,3).state == 1) {
    writeini " $+ $scriptdirhldlsettings.ini $+ " saved resolution 800
  }
  if ($did(hldl_resolutions,4).state == 1) {
    writeini " $+ $scriptdirhldlsettings.ini $+ " saved resolution 1024
  }
  if ($did(hldl_resolutions,5).state == 1) {
    writeini " $+ $scriptdirhldlsettings.ini $+ " saved resolution 1152
  }
  if ($did(hldl_resolutions,6).state == 1) {
    writeini " $+ $scriptdirhldlsettings.ini $+ " saved resolution 1280
  }
  dialog -x hldl_resolutions
}

on *:dialog:hldl:close:0:{
  unset %hldl.*
}

;; by bunkahumpa
;; bh@scriptsurge.org - bunkahumpa.lookitsbobby.com
;; function: returns information from a specified half-life demo file
;; usage: $demo(path\to\demofile.dem).PROP
;; PROP can be: mod, map, or hltv 
alias demo {
  if ($1 == $null) {
    return $null
  }
  else {
    var %file = $shortfn($1)
    if ($exists(%file) == $true) {
      ;;;;;;;;;;;
      ;;  MAP  ;;
      ;;;;;;;;;;;
      if ($prop == map) {
        bread %file 5 50 &map
        ; read the file starting at byte 5 and going for 50 bytes
        var %x = 1
        while (%x <= $bvar(&map,0)) {
          if ($bvar(&map,%x) == 0) {
            ; if the specified byte is 0, replace with a dash in the var
            if (%map) {
              var %map = %map $+ $chr(45)
            }
            else {
              var %map = $chr(45)
            } 
          }
          else {
            ; if it's not 0, put it in the var
            if (%map) {
              var %map = %map $+ $chr($bvar(&map,%x))
            }
            else {
              var %map = $chr($bvar(&map,%x))
            }
          }
          inc %x
        }
        return $gettok(%map,4,45)
      }
      ;;;;;;;;;;;
      ;;  MOD  ;;
      ;;;;;;;;;;;
      if ($prop == mod) {
        bread %file 276 10 &mod
        ; read the file starting at byte 276 and going for 10 bytes
        var %a = 1
        while (%a <= $bvar(&mod,0)) {
          if ($bvar(&map,%x) == 0) {
            ; if the specified byte is 0, replace with a dash in the var
            if (%mod) {
              var %mod = %mod $+ $chr(45)
            }
            else {
              var %mod = $chr(45)
            }
          }
          else {
            ; if it's not 0, put it in the var
            if (%mod) {
              var %mod = %mod $+ $chr($bvar(&mod,%a))
            }
            else {
              var %mod = $chr($bvar(&mod,%a))
            }
          }
          inc %a
        }
        return $gettok(%mod,1,45)
      }
      ;;;;;;;;;;;;;
      ;;  HLTV?  ;;
      ;;;;;;;;;;;;;
      if ($prop == hltv) {
        bread %file 1024 5 &hltv
        ; read the file starting at byte 1024 and going for 5 bytes
        var %b = 1
        while (%b <= $bvar(&hltv,0)) {
          if ($bvar(&hltv,%b) == 0) {
            ; if the specified byte is 0, replace with a dash in the var
            if (%hltv) {
              var %hltv = %hltv $+ $chr(45)
            }
            else {
              var %hltv = $chr(45)
            }
          }
          else {
            ; if it's not 0, put it in the var
            if (%hltv) {
              var %hltv = %hltv $+ $chr($bvar(&hltv,%b))
            }
            else {
              var %hltv = $chr($bvar(&hltv,%b))
            }
          }
          inc %b
        }
        if ($gettok(%hltv,1,45) == otoco) {
          return Yes
        }
        else {
          return No
        }
      }
    }
    else {
      return $null
    }
  }
}
